﻿using System.Linq;

using DevExpress.Xpf.Mvvm;

namespace TestProject
{
    /// <summary>
    /// 상세 뷰 모델
    /// </summary>
    public class DetailViewModel : ViewModelBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 사용자
        /// </summary>
        private User user;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 사용자 - User

        /// <summary>
        /// 사용자
        /// </summary>
        public User User
        {
            get
            {
                return this.user;
            }
            set
            {
                SetProperty(ref this.user, value, () => User);
             }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - DetailViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public DetailViewModel()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 매개 변수 변경시 처리하기 - OnParameterChanged(parameter)

        /// <summary>
        /// 매개 변수 변경시 처리하기
        /// </summary>
        /// <param name="parameter">매개 변수</param>
        protected override void OnParameterChanged(object parameter)
        {
            if(IsInDesignMode)
            {
                User = User.UserArray.FirstOrDefault();
            }
            else
            {
                User = parameter as User;
            }
        }

        #endregion
    }
}