﻿using System.Collections.Generic;
using System.Linq;

using DevExpress.Xpf.Mvvm;

namespace TestProject
{
    /// <summary>
    /// 메인 뷰 모델
    /// </summary>
    public class MainViewModel : ViewModelBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 사용자 열거 가능
        /// </summary>
        private IEnumerable<User> userEnumerable;

        /// <summary>
        /// 선택된 사용자
        /// </summary>
        private User selectedUser;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 사용자 열거 가능 - UserEnumerable

        /// <summary>
        /// 사용자 열거 가능
        /// </summary>
        public IEnumerable<User> UserEnumerable
        {
            get
            {
                return this.userEnumerable;
            }
            set
            {
                SetProperty(ref this.userEnumerable, value, () => UserEnumerable);
            }
        }

        #endregion
        #region 선택된 사용자 - SelectedUser

        /// <summary>
        /// 선택된 사용자
        /// </summary>
        public User SelectedUser
        {
            get
            {
                return this.selectedUser;
            }
            set
            {
                SetProperty(ref this.selectedUser, value, () => SelectedUser);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainViewModel()
        {
            UserEnumerable = User.UserArray;
            SelectedUser   = UserEnumerable.FirstOrDefault();
        }

        #endregion
    }
}